# Matcha Sync Plugin for Xamarin.Forms
A plugin library for offline data sync, provides an SDK library for both Client & Server that makes it easy for developers to create apps that are functional without a network connection. But is also versatile that it can handle custom webapi calls (non-Odata webserver), The reason for creating a plugin for data synchronization it to provide developers other alternative which is FREE and customizable and drop dead simple. 

## Documentation

Get started by reading through the [Matcha Sync Documentation](https://winstongubantes.github.io/MatchaSync/) 

## Nuget

* [Matcha.Sync.Mobile](http://www.nuget.org/packages/Matcha.Sync.Mobile) [![NuGet](https://img.shields.io/nuget/v/Matcha.Sync.Mobile.svg?label=NuGet)](https://www.nuget.org/packages/Matcha.Sync.Mobile/)
* [Matcha.Sync.Api](http://www.nuget.org/packages/Matcha.Sync.Api) [![NuGet](https://img.shields.io/nuget/v/Matcha.Sync.Api.svg?label=NuGet)](https://www.nuget.org/packages/Matcha.Sync.Api/)

## Data Synchronization
Know more about data synchronization from your mobile client to server, Utilize how your app can still interact in "Offline-Mode" where there isn't a network connection and will do sync later. [Get started here](https://winstongubantes.github.io/MatchaSync/)

<img src="https://github.com/winstongubantes/matcha.sync/blob/master/Images/valid.gif" width="400" title="md">

## Pagination
Know more about how Matcha Sync could simplify your paging process and let you concentrate in your apps business-logic. [Get started here](https://winstongubantes.github.io/MatchaSync/Pagination.html)

<img src="https://github.com/winstongubantes/matcha.sync/blob/master/Images/pagination.gif" width="210" title="md">

## Infinite Scroll
Know more about how easy it is to implement infinite scrolling in your app [Get started here](https://winstongubantes.github.io/MatchaSync/InfiniteScroll.html)

<img src="https://github.com/winstongubantes/matcha.sync/blob/master/Images/infinite.gif" width="210" title="md">

## Platform Supported

|Platform|Version|
| ------------------- | :-----------: |
|Xamarin.iOS|iOS 7+|
|Xamarin.Android|API 15+|
|Windows 10 UWP|10+|
|Xamarin.Mac|All|
|Xamarin.tvOS|All|
|Xamarin.watchOS|All|
|.NET Standard|2.0+|
|.NET Core|2.0+|

## Awesome!
 
Matcha sync allows users to interact with a mobile application, viewing, adding, or modifying data, even where there isn't a network connection. Changes are stored in a local database, and once the device is online, the changes can be synced.
